// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"

#include "Transmission/Generated/Service_SDK_types.h"
#include "PluginProjectSettings.h"

#include <memory>

using namespace mixcast::data;
using namespace mixcast::thrift;

class MIXCAST_API SdkData
{
public:
	static std::vector<TrackedObject> TrackedObjects;
	static std::vector<VirtualCamera> VirtualCameras;
	static std::vector<VideoInput> VideoInputs;
	static std::vector<Viewfinder> Viewfinders;

	static TrackedObject* GetTrackedObjectById(std::string id)
	{
		for (int i = 0; i < TrackedObjects.size(); i++)
			if (TrackedObjects[i].identifier.compare(id) == 0)
				return &TrackedObjects[i];
		return nullptr;
	}
	static VirtualCamera* GetCameraById(std::string id)
	{
		for (int i = 0; i < VirtualCameras.size(); i++)
			if (VirtualCameras[i].identifier.compare(id) == 0)
				return &VirtualCameras[i];
		return nullptr;
	}
	static VideoInput* GetVideoInputById(std::string id)
	{
		for (int i = 0; i < VideoInputs.size(); i++)
			if (VideoInputs[i].identifier.compare(id) == 0)
				return &VideoInputs[i];
		return nullptr;
	}
	static Viewfinder* GetViewfinderById(std::string id)
	{
		for (int i = 0; i < Viewfinders.size(); i++)
			if (Viewfinders[i].identifier.compare(id) == 0)
				return &Viewfinders[i];
		return nullptr;
	}

	static UPluginProjectSettings* GetProjectSettings() { return GetMutableDefault<UPluginProjectSettings>(); }
};
